#ifndef EFL_GENERATED_EO_ABSTRACT_CLASS_HH
#define EFL_GENERATED_EO_ABSTRACT_CLASS_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "eo_abstract_class.eo.h"
}


namespace eo {

struct abstract_class;

}

namespace eo_cxx {

namespace eo {

struct abstract_class
{

   static Eo_Class const* _eo_class()
   {
      return(EO_ABSTRACT_CLASS_CLASS);
   }

   operator ::eo::abstract_class() const;
   operator ::eo::abstract_class&();
   operator ::eo::abstract_class const&() const;

   template <typename D>
   struct address_of
   {
      operator ::eo::abstract_class*() const { return static_cast<::eo::abstract_class*>(static_cast<D const*>(this)->p); }
      operator ::eo::abstract_class const*() const { return static_cast<::eo::abstract_class const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::eo::abstract_class const*() const { return static_cast<::eo::abstract_class const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}

namespace eo {

struct abstract_class
      : ::efl::eo::concrete
{
   abstract_class(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : abstract_class(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit abstract_class(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit abstract_class(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   abstract_class(abstract_class const& other)
      : abstract_class(eo_ref(other._eo_ptr()))
   {}

   ~abstract_class() {}


   static Eo_Class const* _eo_class()
   {
      return(EO_ABSTRACT_CLASS_CLASS);
   }

   struct address_of
      : ::eo_cxx::eo::abstract_class::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::eo::abstract_class* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::eo::abstract_class::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::eo::abstract_class const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EO_ABSTRACT_CLASS_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::eo::abstract_class) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::eo::abstract_class>::value, "");

}

inline ::eo_cxx::eo::abstract_class::operator ::eo::abstract_class() const
{
   return *static_cast<::eo::abstract_class const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::eo::abstract_class::operator ::eo::abstract_class&()
{
   return *static_cast<::eo::abstract_class*>(static_cast<void*>(this));
}

inline ::eo_cxx::eo::abstract_class::operator ::eo::abstract_class const&() const
{
   return *static_cast<::eo::abstract_class const*>(static_cast<void const*>(this));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::eo::abstract_class >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::eo::abstract_class >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::eo::abstract_class>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::eo::abstract_class >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::eo::abstract_class, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::eo::abstract_class>)
{
   return (EO_ABSTRACT_CLASS_CLASS);
}

} } }
#endif // EFL_GENERATED_EO_ABSTRACT_CLASS_HH

